//class MyThread extends Threads...
//funktioniert hier nicht einwandfrei:
//Es kommt zu unvorhersehbaren Pixelfehlern
class Threads extends Thread {
  Complex zNeu,zAlt,c,eins,zwei,f;
  double xmin,ymin;
  color farbe;
  PGraphics pg;
  int maxiterations;
  int farbIndex =0;
  int tN;
  int maxN =0; //Kontrolle
  int ordnungSpreizung = 1000;
  double massFuerUnendlich;
  double wh;
  double nZwischen;
  protected boolean running = false;
  int zaehlen;
  double aQMax =0;
  double trapFaktor;
  double aQ,laenge;
  double trapAbstand;
  double[] mittelRadius = new double[8];//maximal 8 Ringe
  double[] trapAbstandRadius = new double[8];//zugehörige Breiten der traps
  boolean trapped;
  boolean knallBunteKreise;
  boolean inEinemKreis = false;  
  boolean sinusXAchse = false;
  boolean sinusYAchse = false;
  double y=0;
  double x=0;
  double r,R;
  double mR,mI;
  Complex [] MP;
  int j;
  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public Threads(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh, int nummer) {
    // benötigte Parameter
    eins = new Complex(1,0);
    zwei = new Complex(2,0);
    f = new Complex(0.8,0.8);
    tN = nummer; 
    wh = pwh;
    xmin=px0; ymin=py0; 
    maxiterations = pmaxiterations;
    massFuerUnendlich = pmUnendlich; 
    aQ =0;
    r=0.06;
    knallBunteKreise = false;//bestimmt die Art der Färbung der Kreise
    for(int i=0; i<8; i++){
      mittelRadius[i] = 0.1 + i*0.05;   
    }  
     for(int i=0; i<8;i++){
      trapAbstandRadius[i] =0.002+ i*0.0002;     
    }
    R=r/Math.sin(Math.PI/8);
    MP = new Complex [8];
    for (int i =0; i<8; i++){
      mR = R*Math.cos(i*Math.PI/4);
      mI = R*Math.sin(i*Math.PI/4);
      MP[i] = new Complex(mR,mI);
    }
    trapAbstand = 0.02;//für kleineren trapAbstand...
    trapFaktor = 4000; // trapFaktor größer wählen: zB. 0.01 und 5000
    pg = createGraphics(width,height/anzahlThreads);
   
  }
  
  public int gibNummer(){
    
    return tN;   
  }
 //////////////////////////////////////////////////////////////
  
  public void run() {
    tN =this.gibNummer(); 
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;       
        double ymax = ymin + wh;
        
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) { 
          double x = xmin; 
          for (int i = 0; i < pg.width; i++) {
            c = new Complex(x,y);
            int n = mandelbrotIteration(c);
           //if(tN ==0)
            pg.pixels[i+j*pg.width] = colorize(n);;
            
            x += dx; 
          }
          y += dy;
        }
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;  
  }  
/////////////////////////////////////////////////////////////////////
int mandelbrotIteration(Complex C) { 
  // nun wird für eine komplexe Zahl bzw. einen Punkt der Ebene getestet, 
  // wohin er bei der Iteration geht. Je nachdem wird er dann später eingefärbt 
  int n = 0;

  trapped = false;
  zAlt = C;
  while (n < maxiterations) {
    //Standard: -------------------------------------------------------------------
     zNeu = (zAlt.multiply(zAlt));
     zNeu = zNeu.addC(C);
    //-----------------------------------------------------------------------------
  //oder:-----------------------------------------------------------------------------
   // zNeu = (zAlt.multiply(zAlt.sinC()));
   // zNeu = zNeu.addC(C.sinC());
  //----------------------------------------------------------------------------------
   // oder:---------------------------------------------------------------------------
    /*zNeu = zAlt.multiply(zAlt);
    zNeu = zNeu.addC(C);
    zNeu = zNeu.multiply(f);*/
  //------------------------------------------------------------------------------
  //Weitere Ideen ------------------------------------------------------------------
  /*zNeu = (zNeu.addC(C)).multiply(zNeu);
    zNeu = zNeu.sinC(); //Alternativen...
    zNeu = (zNeu.multiply(zNeu)).multiply(zNeu);
    zNeu = zNeu.reciproc();
    zNeu = (zNeu.cosC()).multiply(zwei);
    C = C.sinC();
    C = C.reciproc();
    zNeu = zNeu.sqrtC();    
    zNeu = zNeu.reciproc();*/
  //---------------------------------------------------------------
    laenge =zNeu.getLength();
   
    if (laenge > massFuerUnendlich) {
      break;  // für den Chaosbereich
    }
   
    x= Math.abs(zNeu.getRealPart());
    y =Math.abs(zNeu.getImaginaryPart());
    laenge = zNeu.getLength();
   
    if (Math.abs(sinusX(x)-y)< trapAbstand){//im x-Achsen Sinus Bereich gefangen  (erste Präferenz) 
      nZwischen = trapFaktor*Math.abs((float)sinusX(x)-y);
      sinusXAchse = true;
      trapped = true;  n = (int)nZwischen;break;
    }
    
   if (Math.abs(sinusY(y)-x)< trapAbstand ){//im y-Achsen Sinus Bereich gefangen   (zweite Präferenz) 
      nZwischen = trapFaktor*Math.abs((float)sinusY(y)-x);
      sinusYAchse = true;
      trapped = true;  n = (int)nZwischen; break;
    }      
    if (R-r<zNeu.getLength() && zNeu.getLength()<R+r && n >0 ){//gefangen in einem der 8 Kreise     
       j=0; 
       double b=0;
       while(j <8){       
         b = MP[j].subtractC(zNeu).getLength();    
         if (b < r){
            trapped = true;
            inEinemKreis = true;
            int fWert = (int)(512*b);
            if (fWert > 127) fWert =127;
            if (fWert <0) fWert =0;
            n =2* j*128+fWert;  
            break;
         }
       
       j++;
      }
      if(trapped == true)  break;     
    } 
    
    zAlt = zNeu;
    n++;
  }
  return n;
 }
 
/////////////////////////////////////////////////////////////////////////
 double sinusX(double xWert){
   double yWert=0;
   //yWert =0.5*xWert*xWert*xWert*Math.sin(PI*xWert*xWert);   
   yWert =0.5*xWert*xWert*Math.sin(PI*xWert);    
   return yWert; 
 }
///////////////////////////////////////////////////////////////////
 double sinusY(double yWert){
   double xWert=0;
   //xWert = 0.5*yWert*yWert*yWert*Math.sin(PI*yWert*yWert);   //Alternative
   xWert = 0.5*yWert*yWert*Math.sin(PI*yWert);
   return xWert; 
 }
////////////////////////////////////////////////////////////////////
color colorize(int n) {
  // jedes Pixel wird entsprechend der Anzahl Iterationen eingefärbt
  
  if (n == maxiterations){//Ordnung
    farbIndex = (int) aQ % 1024;
    color colOrdnung  = farben.farben1024B[farbIndex];  
    
    return colOrdnung;
    
  }else if(!trapped){  //Chaos ohne Tap
    farbIndex = 4*n % 8192;
    farbe = farben.farben8192Bonbon[farbIndex];
    return farbe; 
    
  }else {//trapped  
   
    farbIndex =5*n % 1024;
    
      if(sinusYAchse) {
       farbe =farben.farbenTrapRot1024[farbIndex];       
       sinusYAchse= false;
    }   
    if(sinusXAchse){
       farbe =farben.farbenTrapBlau1024[farbIndex];  
        sinusXAchse= false;
    }

    if(inEinemKreis){
      if(knallBunteKreise){ 
      farbIndex = n % 1152;
       farbe = farben.farben8Kreise1152[farbIndex]; 
      }else{
       farbIndex = n % 1024;
       farbe = farben.farben8Kreise1024[farbIndex];
      }
       inEinemKreis = false;
    }
    return farbe;
  }
 }
}
